%define name	icewm
%define version	1.3.3
%define theirversion 1.3.1
%define release %mkrel 7

%define with_light 1
%define with_gnome 1
%{?_with_no_light: %{expand: %%global with_light 0}}
%{?_with_no_gnome: %{expand: %%global with_gnome 0}}

%define light_apps          icewm icesh icewmbg icewmhint icewm-session
%define default_apps        %{light_apps} icehelp
%define gnome_apps          %{default_apps} icesound

Name:		%{name}
Summary:	X11 Window Manager
Version:	%{version}
Release:	%{release}
License:	LGPL
Group:		Graphical desktop/Icewm
Epoch:		1

URL:		http://www.icewm.org/
Source:		icewm-%{theirversion}.tar.bz2
Source2:	themes.tar.lzma
Source5:	icewm-16.png
Source6:	icewm-32.png
Source7:	icewm-48.png
Source8:	icewm-starticewm
Source9:	icewm-monochrome.tar.bz2
Source10:	icewm-galaxy.tar.bz2
Source11:	mga-logo.png
Source12:	icewm-menu-xdg

Patch0:		icewm-1.3-dev-mdvconf.patch
# fix bindkey conflict xcin
Patch1:		icewm-1.2.26-xcin_bindy.patch
Patch2:		icewm-1.2.13pre3-defaultfont.patch
Patch3:		icewm-1.3-dev-always-fontset.patch
Patch4:		icewm-1.3-dev-winoptions.patch
Patch7:		icewm-1.2.0pre1-libsupc++.patch
Patch8:		icewm-1.2.5-lib64.patch
Patch10:	icewm-desktop.patch
Patch11:	icewmbg-1.2.14pre11-fixcrash.patch
Patch12:	icewm-1.2.14pre11-background.patch
Patch16:	icewm-1.3-dev-default-theme.patch
Patch18:	icewm-1.2.26-more_virtual_desktops.patch
Patch21:        icewm-1.3.1-fix-build.patch
Patch22:        icewm-1.3.0-gdkicon.patch
Patch23:	icewm-1.3.0-kdeicon.patch
Patch24:	icewm-1.3.0-fdoicon.patch
Patch25:	icewm-1.3.0-fix-focusing-on-raise.patch
Patch26:	icewm-1.3.1-helppath.patch
# from Fedora
Patch100:	icewm-configure.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-root
BuildRequires:  libx11-devel
BuildRequires:  libsm-devel
BuildRequires:  libxrandr-devel
BuildRequires:	autoconf2.5
BuildRequires:	gettext
BuildRequires:	libpcap-devel
BuildRequires:	xpm-devel
BuildRequires:	gnome-desktop-devel
BuildRequires:	gnomeui2-devel
BuildRequires:  libgdk_pixbuf2.0-devel
BuildRequires:  linuxdoc-tools
BuildRequires:  imagemagick
Requires:	desktop-common-data, %{name}-light >= %epoch:%{version}
Requires:	xlockmore
Requires:	xdg-compliance-menu
Requires:	xdg-compliance-autostart
# due to some theme move between icewm and icewm-light, urpmi needs help
Conflicts:	icewm-light < 1.2.20

%description
Window Manager for X Window System. Can emulate the look of Windows'95, OS/2
Warp 3,4, Motif or the Java Metal GUI. Tries to take the best features of the
above systems. Features multiple workspaces, opaque move/resize, task bar,
window list, mailbox status, digital clock. Fast and small.

%package light
Summary:	A light version of Icewm
Group:		Graphical desktop/Icewm
Requires(post): menu
Requires(postun): menu
# due to some theme move between icewm and icewm-light, urpmi needs help
Conflicts:	icewm < 1.2.20

%description light
Window Manager for X Window System. Can emulate the look of Windows'95, OS/2
Warp 3,4, Motif or the Java Metal GUI. Tries to take the best features of the
above systems. Features multiple workspaces, opaque move/resize, task bar,
window list, mailbox status, digital clock. Fast and small.

This is the light version with minimal features.


%if %{with_gnome}
%package gnome
Summary:        A gnome compatible version of Icewm
Group:          Graphical desktop/Icewm
Requires:       %{name}-light = %epoch:%{version}

%description gnome
Window Manager for X Window System. Can emulate the look of Windows'95, OS/2
Warp 3,4, Motif or the Java Metal GUI. Tries to take the best features of the
above systems. Features multiple workspaces, opaque move/resize, task bar,
window list, mailbox status, digital clock. Fast and small.

This is the GNOME version with full GNOME support and with some experimental 
options enabled.
%endif

%prep
%setup -q -a 2 -a 9 -a 10 -n %name-%theirversion
%patch0 -p1 -b .mdkconf
%patch1 -p1 -b .xcin_bindy
%patch2 -p1 -b .defaultfont
%patch3 -p1 -b .fontset
%patch4 -p1 -b .winoptions
%patch7 -p1 -b .libsupc++
%patch8 -p1 -b .lib64
%patch10 -p1 -b .desktop
%patch11 -p1 -b .nocrash
%patch12 -p1 -b .background
%patch16 -p1 -b .default-theme
%patch18 -p1 -b .more_desktop
%patch21 -p1
%patch22 -p1 -b .gdkicon
%patch23 -p1 -b .kdeicon
%patch24 -p1 -b .fdoicon
%patch25 -p1 -b .focus
%patch26 -p1 -b .helppath
%patch100 -p1 -b .configure
autoconf

rm -f po/en.* #- en is not a valid locale

convert %{SOURCE11} -fill \#e5e5e5 -opaque none -alpha off -resize 16x16 galaxy-icewm/menuk-mdk.png
convert galaxy-icewm/menuk-mdk.png galaxy-icewm/Galaxy/taskbar/linux.xpm

mv galaxy-icewm/Galaxy themes

chmod -R a+rX themes
find themes -type f | xargs chmod a-x

rm -r themes/Urbicande

%build

# moving everything to default
mv %{_builddir}/%{name}-%{theirversion} %{_builddir}/%{name}-%{theirversion}-default
install -d %{_builddir}/%{name}-%{theirversion}
mv %{_builddir}/%{name}-%{theirversion}-default %{_builddir}/%{name}-%{theirversion}/default
cd .
# then creating duplicates
for i in light gnome; do cp -a default $i; done

COMMON_CONFIGURE="--sysconfdir=/etc --enable-i18n --enable-nls --with-docdir=%{_docdir} --with-libdir=%{_datadir}/X11/%{name}"

%if %{with_light}
echo "Light Version"
(
	cd light
	CXXFLAGS="$RPM_OPT_FLAGS" %configure2_5x $COMMON_CONFIGURE --enable-lite
	%make
)
%endif

%if %{with_gnome}
echo "Gnome Version"
(
	cd gnome
	CXXFLAGS="$RPM_OPT_FLAGS" %configure2_5x $COMMON_CONFIGURE \
		--with-icesound=oss,esd --enable-menus-gnome2 \
		--enable-xfreetype --enable-antialiasing --enable-guievents
	%make
)
%endif

echo "Standard Version"
(
	cd default
	CXXFLAGS="$RPM_OPT_FLAGS" %configure2_5x $COMMON_CONFIGURE
	%make
        cd doc
        %make
)

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std -C default

# --with-bindir doesn't work
#install -d $RPM_BUILD_ROOT%{_bindir}
#mv $RPM_BUILD_ROOT/usr/bin/* $RPM_BUILD_ROOT%{_bindir}

%if %{with_light}
for binary in %{light_apps}; do 
   install light/src/${binary} $RPM_BUILD_ROOT%{_bindir}/${binary}-light
done
%endif

%if %{with_gnome}
for binary in %{gnome_apps}; do 
   install gnome/src/${binary} $RPM_BUILD_ROOT%{_bindir}/${binary}-gnome
done
%endif

cp -a default/themes $RPM_BUILD_ROOT%{_datadir}/X11/%{name}

install -D -m755 %{SOURCE12} $RPM_BUILD_ROOT%{_sysconfdir}/menu.d/%{name}

# icon
install -D -m644 %{SOURCE6} $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png
install -D -m644 %{SOURCE5} $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png
install -D -m644 %{SOURCE7} $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png

excludes_patt="\(themes/Galaxy\|icewm/icons/\(app_\|xterm_\)\)"
(cd $RPM_BUILD_ROOT%{_datadir} ; find X11/%{name}/{icons,themes} ! -type d -printf "%{_datadir}/%%p\n") | grep -v "$excludes_patt" > other.list
(cd $RPM_BUILD_ROOT%{_datadir} ; find X11/%{name}/{icons,themes}   -type d -printf "%%%%dir %{_datadir}/%%p\n") | grep -v "$excludes_patt" >> other.list

# wmsession support
mkdir -p $RPM_BUILD_ROOT/etc/X11/wmsession.d/
cat << EOF > $RPM_BUILD_ROOT/etc/X11/wmsession.d/07IceWM
NAME=IceWM
ICON=icewm-wmsession.xpm
EXEC=/usr/bin/starticewm
DESC=Lightweight desktop environment
SCRIPT:
exec /usr/bin/starticewm
EOF

install -m 755 %{SOURCE8} $RPM_BUILD_ROOT%{_bindir}/starticewm

# Dadou - Change default background color for distro color
perl -pi -e "s!# DesktopBackgroundColor=.*!DesktopBackgroundColor=\"\"!" %buildroot%{_datadir}/X11/icewm/preferences

%find_lang %{name}
cat %{name}.lang >> other.list

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with_light}
%post light
for app in %{light_apps}; do
	update-alternatives --install %{_bindir}/${app} ${app} %{_bindir}/${app}-light 10
done
	
%{make_session}
if [ -x %{_bindir}/update-menus ]; then %{_bindir}/update-menus; fi

%postun light
if [ "$1" = 0 ]; then
    	if [ -x %{_bindir}/update-menus ]; then %{_bindir}/update-menus; fi
	for app in %{light_apps}; do
		update-alternatives --remove ${app} %{_bindir}/${app}-light
	done
fi
%{make_session}
%endif

%if %{with_gnome}
%post gnome
for app in %{light_apps}; do
	update-alternatives --install %{_bindir}/${app} ${app} %{_bindir}/${app}-gnome 30
done
%{make_session}

%postun gnome
if [ "$1" = 0 ]; then
	for app in %{light_apps}; do
		update-alternatives --remove ${app} %{_bindir}/${app}-gnome
	done
fi
%{make_session}
%endif

%post
for app in %{default_apps}; do
	update-alternatives --install %{_bindir}/${app} ${app} %{_bindir}/${app} 20
done
%{make_session}

%postun
if [ "$1" = 0 ]; then
	for app in %{default_apps}; do
		update-alternatives --remove ${app} %{_bindir}/${app}
	done
fi
%{make_session}

%files -f other.list
%defattr(-,root,root)
%doc default/README default/COPYING default/AUTHORS default/CHANGES default/TODO default/BUGS
%doc default/doc/*.html default/doc/icewm.sgml
%{_bindir}/icesh
%{_bindir}/icehelp
%{_bindir}/icewm
%{_bindir}/icewm-session
%{_bindir}/icewmbg
%{_bindir}/icewmhint
%{_bindir}/icewmtray

%files light
%defattr(-,root,root)
%doc light/COPYING
%dir %{_datadir}/X11/%{name}
%dir %{_datadir}/X11/%{name}/themes
%dir %{_datadir}/X11/%{name}/icons
%dir %{_datadir}/X11/%{name}/ledclock
%dir %{_datadir}/X11/%{name}/taskbar
%dir %{_datadir}/X11/%{name}/mailbox
/etc/menu.d/%{name}
%config(noreplace) /etc/X11/wmsession.d/*
%{_bindir}/starticewm
%{_datadir}/X11/%{name}/mailbox/*
%{_datadir}/X11/%{name}/taskbar/*
%{_datadir}/X11/%{name}/ledclock/*
%{_datadir}/X11/%{name}/icons/app_*
%{_datadir}/X11/%{name}/icons/xterm_*
%{_datadir}/X11/%{name}/keys
%{_datadir}/X11/%{name}/menu
%{_datadir}/X11/%{name}/preferences
%{_datadir}/X11/%{name}/toolbar
%{_datadir}/X11/%{name}/winoptions
#%{_datadir}/X11/%{name}/programs
%{_datadir}/X11/%{name}/themes/Galaxy
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%if %{with_light}
%{_bindir}/*-light
%endif

%if %{with_gnome}
%files gnome
%defattr(-,root,root)
%doc gnome/COPYING
%{_bindir}/*-gnome
%endif






%changelog
* Sun Mar 27 2011 blino <blino> 1:1.3.3-7.mga1
+ Revision: 78180
- buildrequire imagemagick
- use Mageia logo for desktop menu
- remove unused taskbar image
- update background path
- remove old release tags checks
- require desktop-common-data instead of ancient name
- remove old menu method

  + ennael <ennael>
    - imported package icewm


* Tue Feb 15 2011 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1:1.3.3-6mdv2011.0
+ Revision: 637847
- Require xdg-compliance-menu (for script that was previously in
  desktop-common-data)
- Require xdg-compliance-autostart (as discussed recently in cooker list)

* Tue Dec 28 2010 Leonardo Coelho <leonardoc@mandriva.com> 1:1.3.3-5mdv2011.0
+ Revision: 625690
- Fix help file location (#58790).

* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 1:1.3.3-4mdv2011.0
+ Revision: 605960
- rebuild

* Wed Mar 17 2010 Oden Eriksson <oeriksson@mandriva.com> 1:1.3.3-3mdv2010.1
+ Revision: 522917
- rebuilt for 2010.1

* Fri Sep 25 2009 Olivier Blin <oblin@mandriva.com> 1:1.3.3-2mdv2010.0
+ Revision: 449202
- buildrequire gnomeui2-devel
- fix build: pkg-config --cflags gnome-desktop-2.0 doesn't implicitly
  include libgnomeui-2.0 anymore, so add it in explicitly (from Fedora)
- rediff patches (from Arnaud Patard)

* Sat Oct 18 2008 Frederik Himpe <fhimpe@mandriva.org> 1:1.3.3-1mdv2009.1
+ Revision: 295075
- update to new version 1.3.3

* Tue Aug 26 2008 Pixel <pixel@mandriva.com> 1:1.3.1-4mdv2009.0
+ Revision: 276300
- do not call xvt with options not standardized (#43115)

* Thu Jun 12 2008 Pixel <pixel@mandriva.com> 1:1.3.1-3mdv2009.0
+ Revision: 218411
+ rebuild (emptylog)

* Thu Feb 28 2008 Pixel <pixel@mandriva.com> 1:1.3.1-3mdv2008.1
+ Revision: 176402
- drop Chicago.ttf from themes.tar (#38252)
- compress themes.tar with lzma instead of bz2

* Tue Jan 08 2008 Thierry Vignaud <tv@mandriva.org> 1:1.3.1-2mdv2008.1
+ Revision: 146646
- add epoch due to past packaging errors
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Sat Aug 11 2007 Pixel <pixel@mandriva.com> 1.3.1-1mdv2008.0
+ Revision: 61692
- new release, 1.3.1
- restore focusing on raise (as used to be in 1.2.6)

* Wed Jun 20 2007 Olivier Blin <oblin@mandriva.com> 1.3.0-3mdv2008.0
+ Revision: 41852
- add freedesktop.org icon theme support for large/huge sizes
- prefer freedesktop.org icons
- prefer freedesktop.org hicolor theme
- add support for /usr/share/icons/mini and /usr/share/icons/large icons (and remove previous hardcoded hack)

* Wed Jun 20 2007 Olivier Blin <oblin@mandriva.com> 1.3.0-2mdv2008.0
+ Revision: 41657
- use web_browser_section icon for browser in toolbar (mozilla.png does not exist anymore)
- allow to find icons when using gdk, to add icons back in toolbar and menu (Pixel: now you can drop imlib :-p)

* Fri May 18 2007 Pixel <pixel@mandriva.com> 1.3.0-1mdv2008.0
+ Revision: 28093
- new release, 1.3.0
- remove theme Urbicande which makes icewm crash


* Tue Nov 21 2006 Pixel <pixel@mandriva.com> 1.3.0-0.1mdv2007.0
+ Revision: 85741
- need sgml2html to build doc
- Cris B <cris AT beebgames DOT com>
- Use correct X11 buildrequires
- New cvs version
- Drop imlib requirement (bug #24064)
- Disable enable-gradients on gnome version as it doesn't build
- adapt patch0, patch3, patch4, patch16
- drop patch15 (only for imlib which we drop)
- drop patch19 ("light" build seems ok without it)
- drop patch20 (now applied in patch0)

* Sat Oct 28 2006 Stefan van der Eijk <stefan@mandriva.org> 1.2.28-3mdv2007.1
+ Revision: 73589
- rebuild
- rebuild
- 1.2.28

  + Jérôme Soyer <saispo@mandriva.org>
    - New release 1.2.27

* Fri Aug 18 2006 Frederic Crozat <fcrozat@mandriva.com> 1.2.26-5mdv2007.0
+ Revision: 56628
- Only install menu methods and file on 2006.0 and older

* Wed Aug 16 2006 Pixel <pixel@mandriva.com> 1.2.26-4mdv2007.0
+ Revision: 56184
- move from /usr/X11R6/bin to /usr/bin  and  from /usr/X11R6/lib/X11 to /usr/share/X11
- Import icewm

* Mon Jun 19 2006 Stefan van der Eijk <stefan@eijk.nu.lurtspam> 1.2.26-3
- rebuild for png
- %%mkrel

* Fri May 05 2006 Frederic Crozat <fcrozat@mandriva.com> 1.2.26-2mdk
- Add new xdg menu script
- Fix menu-method, we are Mandriva Linux now :)

* Fri Apr 28 2006 Pixel <pixel@mandriva.com> 1.2.26-1mdk
- new release
- drop patch 17 (now unused?)
- refresh patches 1, 18, 19
- fix version (but not using epoch since the bad version only appeared once, in cooker)
- fixes bugzilla #22167

* Tue Feb 28 2006 Jerome Soyer <saispo@mandriva.org> 1.2.25-1mdk
- New release 1.2.25

* Tue Jan 31 2006 Pixel <pixel@mandriva.com> 1.2.24-2mdk
- rebuild to have all subpackages

* Tue Jan 31 2006 Jerome Soyer <saispo@mandriva.org> 1.2.24-1mdk
- New release 1.2.24

* Tue Aug 23 2005 Pixel <pixel@mandriva.com> 1.2.23-3mdk
- use www-browser in the toolbar

* Fri Aug 19 2005 Pixel <pixel@mandriva.com> 1.2.23-2mdk
- fix mute/unmute
- remove broken mozilla calls, use www-browser for one
- fix requires post&postun (thanks to pterjan)

* Thu Aug 18 2005 Pixel <pixel@mandriva.com> 1.2.23-1mdk
- new release
- update patch0
- fix building icewm-light
- replace prereq

* Thu Mar 31 2005 Warly <warly@mandrakesoft.com> 1.2.20-4mdk
- add support for 24 virtual desktops

* Thu Feb 17 2005 Pixel <pixel@mandrakesoft.com> 1.2.20-3mdk
- add some Conflict (due to some theme move between icewm and icewm-light, urpmi needs help)

* Wed Feb 16 2005 Pixel <pixel@mandrakesoft.com> 1.2.20-2mdk
- allow not building light or gnome binaries
- remove requires-on-release from icewm-gnome
- have monochrome theme in the themes directory directly in the tarball
- no need to FIX CRASHES for microGUI/complex and Kubical1.2
- have the Galaxy be the real galaxy theme
- put the default theme (Galaxy) in icewm-light (otherwise the default icewm-light theme is broken)
- better regexp to help dropping many app_* and xterm_* xpms
- icesound now builds again
- fix requires-on-release
- fix icewm menu entry
- fix rights on xpm files
- /etc/menu-methods/icewm is no more marked as a config file
- cleanup

* Sun Feb 13 2005 Crispin Boylan <viewtronix@uklinux.net> 1.2.20-1mdk
- new version
- cleanup build options
- gnome 2 menus

* Tue Nov 30 2004 Pixel <pixel@mandrakesoft.com> 1.2.16-3mdk
- make icewm depend on xlockmore, not icewm-light

* Fri Oct 08 2004 Frederic Lepied <flepied@mandrakesoft.com> 1.2.16-2mdk
- set default theme (patch 16)
- add MCC to toolbar
- merged patch1 and patch9
- depend on xlockmore
- make halt and reboot work

* Thu Oct 07 2004 Frederic Lepied <flepied@mandrakesoft.com> 1.2.16-1mdk
- 1.2.16 (bug fix for full screen apps)

* Sat Oct 02 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 1.2.15-0.pre3.2mdk
- Patch15: fix background dithering

* Thu Aug 05 2004 Frederic Lepied <flepied@mandrakesoft.com> 1.2.15-0.pre3.1mdk
- 1.2.15pre3

* Tue Mar 23 2004 Florin <florin@mandrakesoft.com> 1.2.14-0.pre11.1mdk
- 1.2.14pre11
- update the config patch
- update the fixcrash patch
- update the showdesktop patch
- add the VERSION patch to fix the Help
- add the fr_po patch
- modify the background patch (use default.png)
- add some popular themes
- use mis-fixed fonts instead of adobe-helvetica

